Replace fdt_node_offset() with fdt_find_node_by_path().

From: Wolfgang Grandegger <wg@grandegger.com>

The new name matches more closely the kernel's name, which is also
a much better description.
---

 board/mpc8360emds/mpc8360emds.c |    2 +-
 board/mpc8360emds/pci.c         |    2 +-
 common/cmd_fdt.c                |    6 +++---
 common/fdt_support.c            |   10 +++++-----
 cpu/mpc83xx/cpu.c               |    2 +-
 include/libfdt.h                |    2 +-
 libfdt/fdt_ro.c                 |    2 +-
 7 files changed, 13 insertions(+), 13 deletions(-)

diff --git a/board/mpc8360emds/mpc8360emds.c b/board/mpc8360emds/mpc8360emds.c
index 562eb8b..3f87f09 100644
--- a/board/mpc8360emds/mpc8360emds.c
+++ b/board/mpc8360emds/mpc8360emds.c
@@ -681,7 +681,7 @@ ft_board_setup(void *blob, bd_t *bd)
 	int nodeoffset;
 	int tmp[2];
 
-	nodeoffset = fdt_path_offset (fdt, "/memory");
+	nodeoffset = fdt_find_node_by_path (fdt, "/memory");
 	if (nodeoffset >= 0) {
 		tmp[0] = cpu_to_be32(bd->bi_memstart);
 		tmp[1] = cpu_to_be32(bd->bi_memsize);
diff --git a/board/mpc8360emds/pci.c b/board/mpc8360emds/pci.c
index 158effe..4c7a82b 100644
--- a/board/mpc8360emds/pci.c
+++ b/board/mpc8360emds/pci.c
@@ -311,7 +311,7 @@ ft_pci_setup(void *blob, bd_t *bd)
 	int err;
 	int tmp[2];
 
-	nodeoffset = fdt_path_offset (fdt, "/" OF_SOC "/pci@8500");
+	nodeoffset = fdt_find_node_by_path (fdt, "/" OF_SOC "/pci@8500");
 	if (nodeoffset >= 0) {
 		tmp[0] = cpu_to_be32(hose[0].first_busno);
 		tmp[1] = cpu_to_be32(hose[0].last_busno);
diff --git a/common/cmd_fdt.c b/common/cmd_fdt.c
index 08fe351..7058197 100644
--- a/common/cmd_fdt.c
+++ b/common/cmd_fdt.c
@@ -177,7 +177,7 @@ int do_fdt (cmd_tbl_t * cmdtp, int flag, int argc, char *argv[])
 		if (strcmp(pathp, "/") == 0) {
 			nodeoffset = 0;
 		} else {
-			nodeoffset = fdt_path_offset (fdt, pathp);
+			nodeoffset = fdt_find_node_by_path (fdt, pathp);
 			if (nodeoffset < 0) {
 				/*
 			 	 * Not found or something else bad happened.
@@ -306,7 +306,7 @@ int do_fdt (cmd_tbl_t * cmdtp, int flag, int argc, char *argv[])
 			nodeoffset = 0;
 			printf("/");
 		} else {
-			nodeoffset = fdt_path_offset (fdt, pathp);
+			nodeoffset = fdt_find_node_by_path (fdt, pathp);
 			if (nodeoffset < 0) {
 				/*
 				 * Not found or something else bad happened.
@@ -405,7 +405,7 @@ int do_fdt (cmd_tbl_t * cmdtp, int flag, int argc, char *argv[])
 		if (strcmp(argv[2], "/") == 0) {
 			nodeoffset = 0;
 		} else {
-			nodeoffset = fdt_path_offset (fdt, argv[2]);
+			nodeoffset = fdt_find_node_by_path (fdt, argv[2]);
 			if (nodeoffset < 0) {
 				/*
 				 * Not found or something else bad happened.
diff --git a/common/fdt_support.c b/common/fdt_support.c
index 69099c4..05bf939 100644
--- a/common/fdt_support.c
+++ b/common/fdt_support.c
@@ -92,7 +92,7 @@ int fdt_chosen(void *fdt, ulong initrd_start, ulong initrd_end, int force)
 	/*
 	 * Find the "chosen" node.
 	 */
-	nodeoffset = fdt_path_offset (fdt, "/chosen");
+	nodeoffset = fdt_find_node_by_path (fdt, "/chosen");
 
 	/*
 	 * If we have a "chosen" node already the "force the writing"
@@ -140,7 +140,7 @@ int fdt_chosen(void *fdt, ulong initrd_start, ulong initrd_end, int force)
 		printf("libfdt: %s\n", fdt_strerror(err));
 #endif
 
-	nodeoffset = fdt_path_offset (fdt, "/cpus");
+	nodeoffset = fdt_find_node_by_path (fdt, "/cpus");
 	if (nodeoffset >= 0) {
 		clock = cpu_to_be32(bd->bi_intfreq);
 		err = fdt_setprop(fdt, nodeoffset, "clock-frequency", &clock, 4);
@@ -148,7 +148,7 @@ int fdt_chosen(void *fdt, ulong initrd_start, ulong initrd_end, int force)
 			printf("libfdt: %s\n", fdt_strerror(err));
 	}
 #ifdef OF_TBCLK
-	nodeoffset = fdt_path_offset (fdt, "/cpus/" OF_CPU "/timebase-frequency");
+	nodeoffset = fdt_find_node_by_path (fdt, "/cpus/" OF_CPU "/timebase-frequency");
 	if (nodeoffset >= 0) {
 		clock = cpu_to_be32(OF_TBCLK);
 		err = fdt_setprop(fdt, nodeoffset, "clock-frequency", &clock, 4);
@@ -185,7 +185,7 @@ int fdt_env(void *fdt)
 	 * See if we already have a "u-boot-env" node, delete it if so.
 	 * Then create a new empty node.
 	 */
-	nodeoffset = fdt_path_offset (fdt, "/u-boot-env");
+	nodeoffset = fdt_find_node_by_path (fdt, "/u-boot-env");
 	if (nodeoffset >= 0) {
 		err = fdt_del_node(fdt, nodeoffset);
 		if (err < 0) {
@@ -305,7 +305,7 @@ int fdt_bd_t(void *fdt)
 	 * See if we already have a "bd_t" node, delete it if so.
 	 * Then create a new empty node.
 	 */
-	nodeoffset = fdt_path_offset (fdt, "/bd_t");
+	nodeoffset = fdt_find_node_by_path (fdt, "/bd_t");
 	if (nodeoffset >= 0) {
 		err = fdt_del_node(fdt, nodeoffset);
 		if (err < 0) {
diff --git a/cpu/mpc83xx/cpu.c b/cpu/mpc83xx/cpu.c
index e934ba6..ef44581 100644
--- a/cpu/mpc83xx/cpu.c
+++ b/cpu/mpc83xx/cpu.c
@@ -460,7 +460,7 @@ ft_cpu_setup(void *blob, bd_t *bd)
 	int  j;
 
 	for (j = 0; j < (sizeof(fixup_props) / sizeof(fixup_props[0])); j++) {
-		nodeoffset = fdt_path_offset(fdt, fixup_props[j].node);
+		nodeoffset = fdt_find_node_by_path(fdt, fixup_props[j].node);
 		if (nodeoffset >= 0) {
 			err = (*fixup_props[j].set_fn)(blob, nodeoffset, fixup_props[j].prop, bd);
 			if (err < 0)
diff --git a/include/libfdt.h b/include/libfdt.h
index f8bac73..e080028 100644
--- a/include/libfdt.h
+++ b/include/libfdt.h
@@ -77,7 +77,7 @@ int fdt_subnode_offset_namelen(const void *fdt, int parentoffset,
 			       const char *name, int namelen);
 int fdt_subnode_offset(const void *fdt, int parentoffset, const char *name);
 
-int fdt_path_offset(const void *fdt, const char *path);
+int fdt_find_node_by_path(const void *fdt, const char *path);
 
 struct fdt_property *fdt_get_property(const void *fdt, int nodeoffset,
 				      const char *name, int *lenp);
diff --git a/libfdt/fdt_ro.c b/libfdt/fdt_ro.c
index 4e2c325..e5518c6 100644
--- a/libfdt/fdt_ro.c
+++ b/libfdt/fdt_ro.c
@@ -129,7 +129,7 @@ int fdt_subnode_offset(const void *fdt, int parentoffset,
  * Searches for the node corresponding to the given path and returns the
  * offset of that node.
  */
-int fdt_path_offset(const void *fdt, const char *path)
+int fdt_find_node_by_path(const void *fdt, const char *path)
 {
 	const char *end = path + strlen(path);
 	const char *p = path;